//To run this file from terminal put it in a folder, cd to the folder and input
//gcc -o tracepqr tracepqr.c -lm && ./tracepqr
//To run successive compiled versions type ./depthf

#include <stdio.h>
#include <math.h>
#include <complex.h>
#include <time.h>

double _Complex  fracfunct(int *s,int sl,int opt,double _Complex val);


int main(void)
{
    //double _Complex val=2;
   // int p=3,q=5,opt=0;
     double _Complex val=1.92643349-0.02738420i;
     int p=143,q=1561,opt=0;
  // double _Complex val=1.61691788-1.29437374i;
  //  int p=377,q=610,opt=0;
   double ep=1e-8;
    
    int g,hld,h1,h2,p0,q0,p1,q1,ph,qh,its,i;
    int s[200],sl=0;
    double _Complex vh,h,f,df;
    h=(1+I)*1e-7;
    h1=p; //Find gcd(p,q)
    h2=q;
    while (h2%h1>0)
    {
       hld=h2%h1;
       h2=h1;
       h1=hld;
    }
    g=h1;
    p=p/g;
    q=q/g;
    p0=0; // Generate Farey sequence for p/q
    q0=1;
    p1=1;
    q1=0;
    ph=p0+p1;
    qh=q0+q1;
    while ((p!=ph) || (q!=qh))
       // if (ph/qh>p/q)
        if (ph*q>p*qh)
        {
            p1=ph;
            q1=qh;
            ph=ph+p0;
            qh=qh+q0;
            s[sl]=0;
            sl=sl+1;
        }
        else
        {
            p0=ph;
            q0=qh;
            ph=ph+p1;
            qh=qh+q1;
            s[sl]=1;
            sl=sl+1;
        }
    its=500;
    for (i=0;i<its;i++) //Newton's iteration loop
    {
        vh=val;
        f=fracfunct(s,sl,opt,val)-2;
        df=(fracfunct(s,sl,opt,val+h)-fracfunct(s,sl,opt,val-h))/2/h;
        val=val-f/df;
        if (cabs(vh-val)<ep)
        {
            printf("OK %d %4.12f %4.12f %4.12f\n",i,cabs(vh-val),creal(val),cimag(val));
            break;
        }
    }
    if (i==its)
        printf("Bad:%d %4.12f %4.12f\n",i,creal(val),cimag(val));
}

    double _Complex  fracfunct(int *s, int sl,int opt,double _Complex val)
    {
        double _Complex t0,t1,t2,h;
        int i;
        t0=val;
        if (opt<2)
            t1=val+2i;
        else
            t1=val+sqrt(2)*1i;
        t2=2;
        for (i=0;i<sl;i++)
        {
            if (s[i]==0)
            {
                h=t1*t0-t2;
                t2=t1;
                t1=h;
            }
            else
            {
                h=t1*t2-t0;
                t0=t1;
                t1=h;
            }
        }
        return(t1);
    }
    