/*
    File:       SillyBalls.m

    Contains:   View class for drawing lots of silly balls.

    Written by: Quinn "The Eskimo!"

    Created:    Thu 05-Jun-1997

    Copyright:  (c)1997 by Apple Computer, Inc., all rights reserved.

    Change History (most recent first):
                    7/5/00	KG	updated for Project Builder on DP4

    You may incorporate this sample code into your applications without
    restriction, though the sample code has been provided "AS IS" and the
    responsibility for its operation is 100% yours.  However, what you are
    not permitted to do is to redistribute the source as "DSC Sample Code"
    after having made changes. If you're going to re-distribute the source,
    we require that you make it clear in the source that the code was
    descended from Apple Sample Code, but that you've made changes.
*/

#import "SillyBallView.h"
#import "Controller.h"
#import <complex.h>
#import "math.h"
#include <time.h> 

typedef double cno[2];

typedef double _Complex arry[2][2];
time_t start,end;

@implementation SillyBallView

double tra = 1.61891069;
double tia = -0.80846358;
double trb = 1.66692448;
double tib = -0.40921981;
double trab = 0.0;
double tiab = 0.0;
double epsi = 0.001;
int levmx = 1000;
double altroot = 0;
double tmr = 10;
double neck = 0;
double mag=0.045;
double nfree=0;
int iterate = 21;
int offscr = 0;

//int finish = 10000;
//const double	gam = 2.0;
//int huge = 10000;
const long		mysizc 		= 480;  //Should be a multiple of 8
const double	iterp 		= 0.5;

const short		kMaxIterations	= 2000;
const long 		overflow 		= 32000000;
const double	kThreshold		= 0.005;

long 			nx,ny;
double 			xmin,xmax,ymin,ymax; 
int 			maxiter;
int				loop;
double			t1,t2,t3,t4;
double			centx, centy;
long			ms2, ms8, mysiz;
//double a=0.27334;
//double b=0.00742;
//double a=-1;
//double b=0;

int stps=50;
int	nw, level;
cno  root1, root2;
long iters;
NSRect currentFrame;
long			didredraw=1;
long			didredrawo=0;
double curs;
double curw,curh;
double oldw=480;
double oldh=480;

void plot2(cno myp, int itr,unsigned char *  bitmapData)  //Set up to NS draw points as rects but disabled

{
	short ix,iy;
	double r,g,b;
	int pos2;
	double mag2 = 0.99;
	
	ix=curs*mag2/2*(-(myp)[0])+floor(curw/2);
	iy=curs*mag2/2*(-(myp)[1])+floor(curh/2);
	if ((ix>=0) && (ix<curw) && (iy>=0) && (iy<curh))
	{
	switch (itr)
		{
			case 0:
			{
				r=0;
				g=0;
				b=0;
				break;
			}
			case 1:
			{
				r=0;
				g=0;
				b=0.8;
				break;
			}
			case 2:
			{
				r=0.8;
				g=0;
				b=0;
				break;
			}
			case 3:
			{
				r=0;
				g=0.6;
				b=0.6;
				break;
			}
			case 4:
			{
				r=0.6;
				g=0;
				b=0.6;
				break;
			}
		}
		pos2=3*((iy-1)*curw+(ix-1));
		bitmapData[pos2]=(int)255*r;//fabs(cos(s*cabs(c)));
		bitmapData[pos2+1]=(int)255*g;//fabs(cos(s*carg(c)));
		bitmapData[pos2+2]=(int)255*b;//fabs(cos(s*sqrt(cabs(c))));
	}
}

double _Complex fixp(arry T)
{
    double _Complex z,tr,tr2,a,b,c,d;
    double _Complex k;
    a=T[0][0];
    b=T[0][1];
    c=T[1][0];
    d=T[1][1];
    tr=a+d;
    tr2=a*a+2*b*c+d*d;
    k=((tr+csqrt(tr2-4))/2)*((tr+csqrt(tr2-4))/2);
    if (cabs(k)>1)
        z=(-(d-a)+csqrt((d-a)*(d-a)+4*b*c))/(2*c);
    else
        z=(-(d-a)-csqrt((d-a)*(d-a)+4*b*c))/(2*c);
    return(z);
}


void mult(arry a,arry b,arry c)
{
    int i,j;
    for (i=0;i<2;i++)
        for (j=0;j<2;j++)
            c[i][j]=a[i][0]*b[0][j]+a[i][1]*b[1][j];
}

void inv(arry a, arry c)
{
    double _Complex d;
    d=a[0][0]*a[1][1]-a[0][1]*a[1][0];
    c[0][0]=a[1][1]/d;
    c[0][1]=-a[0][1]/d;
    c[1][0]=-a[1][0]/d;
    c[1][1]=a[0][0]/d;
}

void depthfirst(double tra, double tia, double trab, double tiab, double epsi,int levmx, double mag,double nfree,double altroot,double tmr,double neck,int iterate,int offscr,unsigned char *  bitmapData)
//void depthfirst(unsigned char *  bitmapData)
{
    //FILE *mf;    
    //const char base[] = "DF";
    //char filename [100];
    
    //double _Complex ta=1.9264340533-0.0273817919*I,tb=2;
    //double _Complex ta=1.80785524+0.136998688*I, tb=2;
	double _Complex ta=1.61891069-0.80846358*I,tb=1.66692448-0.40921981*I;
	int levmaxx=10000,siz=1100,levmax;
    double ep=0.001,scal=0.1;
/*	double _Complex ta, tb;
	 int levmax,siz=1100;
	 double ep,scal;*/
	
	// int M[siz][siz],siz2,sizs;
	double dif;
	int siz2,sizs;
    double _Complex gens[2][2][4];
	double _Complex word[3][3][levmaxx+1];
    int state[levmaxx+1];
    int tags[levmaxx+1];
    double _Complex fix[3][4];
    int i,j;
    double _Complex tab;//,p,q,z0,z;
	double _Complex p,q,z0,z,Q,tC,R,zo;
    arry a,b,ab,A,B;
    arry h1,h2,h3;
    int lev,fl,plt,stps,art=0,nk=0,spec=0,itrate=0,ofsc=0;;
    double _Complex oldpoint,newpoint,midpoint;
    double x;
	cno zz;
	//sprintf(filename, "%s %e %e %e %e.txt",base,creal(ta),cimag(ta),creal(tb),cimag(tb));
    //printf("filename = \"%s\"\n", filename);
	// mf=fopen(filename,"w");
	
	//printf("%e %e %e %e %d %e %e\n",tra,tia,trb,tib,levmx,epsi,mag);
	 ta=tra+tia*I;
	 tb=trb+tib*I;
	 ep=epsi;
	 levmax=levmx;
	 scal=mag;
	 spec=2*(int)nfree;
	 art=(int)altroot;
	 nk=(int)neck;
	 itrate=iterate;
	 if (levmax>levmaxx)
		levmax=levmaxx;
	 ofsc=offscr;
	
	 int FSA[19][4]={{1,2,3,4},{1,5,-1,4},{7,2,8,-1},{-1,2,3,6},{9,-1,10,4},{7,2,11,-1},{12,-1,10,4},{1,5,-1,13},{-1,2,3,14},{1,15,-1,4},{-1,16,3,4},{-1,2,3,17},{1,18,-1,4},{9,-1,-1,4},{-1,-1,10,4},{7,2,-1,-1},{-1,2,8,-1},{-1,-1,10,4},{7,2,-1,-1}};
	
	time (&start);
	ep=ep/scal;
	/* for (i=0;i<siz;i++)
	 for (j=0;j<siz;j++)
	 M[i][j]=1;*/
    siz2=siz/2;
    sizs=(int)siz2*10.0/11;
    //grandma's recipe
    if (spec==0)
    {
        p=-ta*tb;
        q=ta*ta+tb*tb;
       // tab=(-p-csqrt(p*p-4*q))/2;
  		if (art==0)
			tab=(-p-csqrt(p*p-4*q))/2;
		else
			tab=(-p+csqrt(p*p-4*q))/2;
		z0=((tab-2)*tb)/(tb*tab-2*ta+2*I*tab);
        ab[0][0]=tab/2;
        ab[0][1]=(tab-2)/(2*z0);
        ab[1][0]=(tab+2)*z0/2;
        ab[1][1]=tab/2;
        b[0][0]=(tb-2*I)/2;
        b[0][1]=tb/2;
        b[1][0]=tb/2;
        b[1][1]=(tb+2*I)/2;
    }
    else
    {
		p=-ta*tb;
		q=ta*ta+tb*tb-2;
		if (art==0)
			tab=(-p-csqrt(p*p-4*q))/2;
		else
			tab=(-p+csqrt(p*p-4*q))/2;
        tC=ta*ta+tb*tb+tab*tab-ta*tb*tab-2; //Grandma's three parameter double alarm
        Q=csqrt(2-tC);
        if ((cabs(tC+I*Q*csqrt(tC+2))>=2+1e-15))
            R=csqrt(tC+2);
        else
            R=-csqrt(tC+2);
        zo=(tab-2)*(tb-R)/(tb*tab-2*ta+1i*Q*tab);
        //a=[ta/2 (ta*tab-2*tb+2i*Q)/((2*tab+4)*zo);(ta*tab-2*tb-2i*Q)*zo/(2*tab-4) ta/2];
        //b=[(tb-1i*Q)/2 (tb*tab-2*ta-1i*Q*tab)/((2*tab+4)*zo);(tb*tab-2*ta+1i*Q*tab)*zo/(2*tab-4) (tb+1i*Q)/2];
        a[0][0]=ta/2;
        a[0][1]=(ta*tab-2*tb+2*I*Q)/((2*tab+4)*zo);
        a[1][0]=(ta*tab-2*tb-2*I*Q)*zo/(2*tab-4);
        a[1][1]=ta/2;
        b[0][0]=(tb-I*Q)/2;
        b[0][1]=(tb*tab-2*ta-I*Q*tab)/((2*tab+4)*zo);
        b[1][0]=(tb*tab-2*ta+I*Q*tab)*zo/(2*tab-4);
        b[1][1]=(tb+I*Q)/2;
        
    }
    inv(b,B);
    if (spec==0)
        mult(ab,B,a);
    inv(a,A);
    for (i=0;i<2;i++) for (j=0;j<2;j++) gens[i][j][0]=a[i][j];
    for (i=0;i<2;i++) for (j=0;j<2;j++) gens[i][j][1]=b[i][j];
    for (i=0;i<2;i++) for (j=0;j<2;j++) gens[i][j][2]=A[i][j];
    for (i=0;i<2;i++) for (j=0;j<2;j++) gens[i][j][3]=B[i][j];
    //stfl=1;
    //oldpoint=0;
    //stpt=0;
    mult(b,a,h1); mult(A,h1,h2); mult(B,h2,h3); fix[0][0]=fixp(h3);
    mult(A,b,h1); mult(B,h1,h2); mult(a,h2,h3); fix[0][1]=fixp(h3);
    mult(B,A,h1); mult(a,h1,h2); mult(b,h2,h3); fix[0][2]=fixp(h3);
    mult(a,B,h1); mult(b,h1,h2); mult(A,h2,h3); fix[0][3]=fixp(h3);
    fix[1][0]=fixp(a); fix[1][1]=fixp(b); fix[1][2]=fixp(A); fix[1][3]=fixp(B);
    mult(B,a,h1); mult(A,h1,h2); mult(b,h2,h3); fix[2][0]=fixp(h3);
    mult(a,b,h1); mult(B,h1,h2); mult(A,h2,h3); fix[2][1]=fixp(h3);
    mult(b,A,h1); mult(a,h1,h2); mult(B,h2,h3); fix[2][2]=fixp(h3);
    mult(A,B,h1); mult(b,h1,h2); mult(a,h2,h3); fix[2][3]=fixp(h3);
    lev=0;
    tags[0]=0;
    state[0]=0;
    for (i=0;i<2;i++) for (j=0;j<2;j++) word[i][j][0]=gens[i][j][0];
    
    while (~((lev==-1)&&(tags[0]==1)))
    {
        fl=0;
        if (spec==2)
            if (state[lev]==-1)
                fl=1;
        while (fl==0)
        {
            z=fix[0][tags[lev]];
            newpoint=(word[0][0][lev]*z+word[0][1][lev])/(word[1][0][lev]*z+word[1][1][lev]);
            z=fix[2][tags[lev]];
            oldpoint=(word[0][0][lev]*z+word[0][1][lev])/(word[1][0][lev]*z+word[1][1][lev]);
            if (nk>0)
			{
			z=fix[1][tags[lev]];
            midpoint=(word[0][0][lev]*z+word[0][1][lev])/(word[1][0][lev]*z+word[1][1][lev]);            
			}
			plt=0;
			x=scal*cabs(newpoint);
			if (ofsc>0)		
				if (x>50) //Chaotic instability
				{
				   // printf("exiting...\n");
					return;
				}
			if (lev==levmax) 
				if (tmr>0)
				{
					time (&end);
					dif=difftime (end,start);
					if (dif > tmr)
						return;
				}
			if (nk>0)
			{
				if ((lev==levmax) || ((cabs(newpoint-midpoint)<ep)&&(cabs(midpoint-oldpoint)<ep)))
				{
					plt=1;
					if (x>1.5) //Limit set off screen
					{
						fl=1;
						break;
					}
				}		
			}
			else
			{
				if ((lev==levmax) || (cabs(newpoint-oldpoint)<ep))
				{
					plt=1;			
					if (x>1.5) //Limit set off screen
					{
						fl=1;
						break;
					}
				}		
			}
			if (plt==1)
            {
                fl=1;
                //fprintf(mf,"%e %e %e %e ",creal(newpoint),cimag(newpoint),creal(oldpoint),cimag(oldpoint));
                z=newpoint-oldpoint;
                if (fabs(cimag(z))>fabs(creal(z)))
                {
                    stps=1;
                    x=ceil(fabs(scal*cimag(z)*siz2));
                    if (x>1) stps=x;
                }
                else
                {
                    stps=1;
                    x=ceil(fabs(scal*creal(z)*siz2));
                    if (x>1)  stps=x;
                }
                //zs=linspace(scal*oldpoint,scal*newpoint,stps);
                for (j=0;j<=stps;j++)
                {
                    z=scal*(newpoint*j/stps+oldpoint*(stps-j)/stps);
                    if ((fabs(creal(z))<1.0) && (fabs(cimag(z))<1.0))
                        //M[(int)(siz2+floor(sizs*creal(z)))][(int)(siz2+floor(sizs*cimag(z)))]=0;
					{
						zz[0]=creal(z);
						zz[1]=cimag(z);
						if (iterate>0)
							plot2(zz,tags[iterate-1]+1,bitmapData);
						if (iterate==0)
							plot2(zz,0,bitmapData);
						if (iterate==-1)
							plot2(zz,tags[lev]+1,bitmapData);
					}
					
				}
            }
            else
                fl=0;
            if (fl==1)
            {
            }
            else
            {
                lev=lev+1; //go forward
                tags[lev]=(tags[lev-1]+1)%4;
                if (lev==0)
                {
                    for (i=0;i<2;i++) for (j=0;j<2;j++)
                        word[i][j][lev]=gens[i][j][tags[lev]];
                    if (spec==2) state[lev]=tags[lev];
                }
                else
                {
                    for (i=0;i<2;i++) for (j=0;j<2;j++)
                    {
                        h1[i][j]=word[i][j][lev-1];
                        h2[i][j]=gens[i][j][tags[lev]];
                    }
                    mult(h1,h2,h3);
                    for (i=0;i<2;i++) for (j=0;j<2;j++)
                        word[i][j][lev]=h3[i][j];
                    if (spec==2)
                    {
                        state[lev]=FSA[state[lev-1]][tags[lev]];
                        if (state[lev]==-1) fl=1;
                    }
                }
            }
        }
        fl=1;
        while (fl==1)
        {
            lev=lev-1; //go backward
            if ((lev==-1) || ((tags[lev+1]+3)%4 != ((tags[lev]+2)%4))) //available turn
            {
                fl=0;
            }
        }
        if ((lev==-1)&&(tags[0]==1))
        {
            //M=myplot(scal,M,stpt,oldpoint,siz);
           // printf("%d %d %d %d\n", tags[0]+1,tags[1]+1,tags[2]+1,tags[3]+1);
           // printf("Elasped time is %.0lf seconds.\n", dif );
            break; //finished!!
        }
        
        lev=lev+1;
        if (tags[lev]>0)
            tags[lev]=(tags[lev]-1)%4; //turnandgoforward
        else
            tags[lev]=(tags[lev]+3)%4;
        
      /*  if (lev<3) //progress clock for long iterations
		{
			time (&end);
			dif=difftime (end,start);
			printf("%d %d %d %d ", tags[0]+1,tags[1]+1,tags[2]+1,tags[3]+1);
			printf("%.1lf sec\n", dif ); 
		}*/
        if (lev==0)
        {
            for (i=0;i<2;i++) for (j=0;j<2;j++)
            {
                word[i][j][lev]=gens[i][j][tags[lev]];
                //state[0]=tags[0];
            }
        }
        else
        {
            for (i=0;i<2;i++) for (j=0;j<2;j++)
            {
                h1[i][j]=word[i][j][lev-1];
                h2[i][j]=gens[i][j][tags[lev]];
            }
            mult(h1,h2,h3);
            for (i=0;i<2;i++) for (j=0;j<2;j++)
                word[i][j][lev]=h3[i][j];
            if (spec==2)
            {
                state[lev]=FSA[state[lev-1]][tags[lev]];
                lev=lev+1-1;
                // if (state[lev]==-1 fl=1;
            }
        }
        
    }
    
    /*for(i=0;i<siz;i++)
        for(j=0;j<siz;j++)
            fprintf(mf,"%d ",M[i][j]);
    fclose(mf);
    time (&end); 
    dif=difftime (end,start);
	return(0);*/
}


void setab(double Tar, double Tai, double Tbr, double Tbi, double sc, double nf, int st, int lm, double ep,double al,double tm,double nk, int it,int os)
{
	tra=Tar;
	tia=Tai;
	trb=Tbr;
	tib=Tbi;
	mag=sc;
	nfree=nf;
	stps=st;
	levmx=lm;
	epsi=ep;
	altroot=al;
	tmr=tm;
	neck=nk;
	iterate=it;
	offscr=os;
	
	//steps=0;
	//printf("derf = %f\n", derf);
	didredraw=didredraw+1;
	//[self drawAnother: source:nil]
}


- (id)initWithFrame:(NSRect)frameRect
    // See comment in interface part.
{
    self = [super initWithFrame:frameRect];
    if (self != nil) {

        // Init some basic instance variables.
        
        running = NO;
        textString = @"Bo3b";
        textSize = [ textString sizeWithAttributes:nil ];

        // Initialise the other instance variables,
        // and start the drawintg timer.
        
        [self setTimerPeriod:3 source:nil];
    }
	//[cReal setFloatValue:a];
	//[cImag setFloatValue:b];
	//itf();
    return (self);
}

- (void)dealloc
    // See comment in interface part.
{
    [repeatTimer release];
    [super dealloc];
}

- (void)setTimerRunning:(BOOL)run source:(id)source
    // See comment in interface part.
{
    if ( !running && run) {
        // If we're not running and we've been told to run, we'd
        // better start the timer.  Set it up so that it calls
        // our drawAnother: method periodically to draw a ball.
        // The timer period is based on the repeatPeriod instance
        // variable (as controlled by the user via the Ball Rate
        // slider, which we feed into a maths function (real_time_
        // period = 10 ** - ball_rate_slider) to get a pleasing
        // non-linearity.
        
       // repeatTimer = [[NSTimer scheduledTimerWithTimeInterval:pow(2, -repeatPeriod)
          repeatTimer = [[NSTimer scheduledTimerWithTimeInterval:pow(2, -4)
		                    target:self
                            selector:@selector(drawAnother:)
                            userInfo:nil
                            repeats:YES
            	      ] retain];
        running = YES;
		
    } else if (running && !run) {

        // We're running and we've been told not to, so let's stop.
        
        [repeatTimer invalidate];
        [repeatTimer release];
        repeatTimer = nil;
        running = NO;
    }

    // Now update menu item to reflect any changes of running status.
    
    if (startStopMenuItem != nil) {
        if (running) {
            [ startStopMenuItem setTitle:@"Stop"];
        } else {
            [ startStopMenuItem setTitle:@"Start"];
        }
    }

    // Now set the value of the user interface based on the current repeat
    // period.  Two things to note here.  Firstly, we conditionalise
    // this by a test whether the view is not nil because the first
    // time we run (called from initWithFrame:) the views have not
    // yet been set up properly because we're being dearchived out
    // of a NIB file.  While it doesn't hurt to call methods on
    // nil objects (it's defined as a no-op in Objective-C), I wanted
    // to explicitly highlight this edge case.
    //
    // The second thing to notice is that we don't set the view
    // if it was the user interface element that prompted the change
    // (presumably it's already changed to the appropriately value).
    // This doesn't have a big effect in this specific case, but you
    // could imagine it causing weird effects in other cases.

    if (sliderView != nil) {
        if (sliderView != source) {
            [sliderView setFloatValue:repeatPeriod];
        }
    }
    if (textView != nil) {
        if (textView != source) {
            [textView setFloatValue:repeatPeriod];
        }
    }
}

- (void)setTimerPeriod:(float)repPeriod source:(id)source
    // See comment in interface part.
{
    // Change the instance variable, then stop the repeat
    // timer (if it's running) and start it again with the
    // right period.
    
    repeatPeriod = repPeriod;
    if (running) {
        [self setTimerRunning:NO source:source];
    }
    [self setTimerRunning:YES source:source];
}

static float RandFloat(void)
    // Returns a random floating point number between
    // 0.0 and 1.0.
{
    return ((float) rand() / (float) RAND_MAX);
}

enum {
    kBallSize = 30
};

- (void)drawRandomBallInside:(const NSRect *)rect
    // See comment in interface part.
{
    float x, y;
    NSBezierPath *oval;

    // Calculate where the ball should go.
    
    x = rect->origin.x + rect->size.width * RandFloat();
    y = rect->origin.x + rect->size.height * RandFloat();

    // Set the current colour to a random RGB value.

    [[NSColor colorWithDeviceRed:RandFloat() green:RandFloat() blue:RandFloat() alpha:1.0] set];

    // Now construct a bezier path for an circle and draw it.
    
    oval = [NSBezierPath bezierPath];
    [oval appendBezierPathWithOvalInRect:NSMakeRect(x, y, kBallSize, kBallSize)];
    [oval fill];

    // Now set the current colour to black and draw
    // the text centred in the ball.
    
    [[NSColor blackColor] set];
    [textString drawAtPoint:NSMakePoint(x + kBallSize / 2 - textSize.width / 2,
                                        y) withAttributes:nil];
}

- (void)drawRect:(NSRect)rect
    // See comment in interface part.
{
    // Do nothing.  In a normal view, you would update the visual
    // representation of your view inside this method.  However, SillyBallView
    // does not remember which balls that it's drawn, so there is nothing it
    // can draw in this meathod.  Instead the drawing happens asynchronously
    // inside the drawAnother: method.  See the notes in ReadMe.rtf for details.
}

- (void)drawAnother:(id)source // timer
    // See comment in interface part.
{
    NSRect visRect;
	int x;
	// Lock focus on ourselves.  We need to do this because we're drawing
    // outside of the context of NSView's drawRect: method.  This is relatively
    // unusual behaviour for a view.  See the discussion of this in ReadMe.rtf.
    
    [self lockFocus];
	
	visRect = [self visibleRect];
	currentFrame=visRect;
	curw=currentFrame.size.width;
	curh=currentFrame.size.height;
	if ((!(curh==oldh)&&(curw==oldw))||(didredraw>didredrawo))
		{
		[myImage release];
		oldw=curw;
	oldh=curh;
	if (curw<curh)
		curs=curw;
	else
		curs=curh;
	    frame = currentFrame;
        window = [self window];

        myImage = [NSBitmapImageRep alloc];
        [myImage
			initWithBitmapDataPlanes:NULL
			pixelsWide:frame.size.width pixelsHigh:frame.size.height
            bitsPerSample:8 samplesPerPixel:3 hasAlpha:NO isPlanar:NO
            colorSpaceName:NSCalibratedRGBColorSpace
            bytesPerRow:(frame.size.width*3) bitsPerPixel:0
        ];
        bitmapData = [myImage bitmapData];

        for (x=0; x < (frame.size.width * frame.size.height * 3); x++)
        {
            bitmapData[x] = 255;
        }
		
    
	if (steps<=1)
		//miim(a,b,bitmapData);
		depthfirst(tra,tia,trb,tib,epsi,levmx,mag,nfree,altroot,tmr,neck,iterate,offscr,bitmapData);
		//depthfirst(bitmapData);
	[myImage drawInRect:currentFrame];
   
    [self unlockFocus];
	

    [[self window] flushWindow];
	if (didredraw>didredrawo)
		didredrawo=didredraw;
	}
}

- (void)forceRedraw:(id)source
    // See comment in interface part.
{
    [self setNeedsDisplay:YES];
}

- (void)startOrStop:(id)source
    // See comment in interface part.
{
    [self setTimerRunning:!running source:source];
}

- (void)setPeriod:(id)source
    // See comment in interface part.
{
    [self setTimerPeriod:[source floatValue] source:source];
}

@end
