function [a,b]=grandma(ta,tb,posroot,opt,tab)
if nargin<3
    posroot=false;
end
if nargin<4
    opt=0;
end
if nargin<5 %Calculate the trace Tab from the grandfather identity
    p=-ta*tb;
    q=ta^2+tb^2;
    if posroot
        tab=(-p+(p^2-4*q)^0.5)/2;
    else
        tab=(-p-(p^2-4*q)^0.5)/2;
    end
    z0=((tab-2)*tb)/(tb*tab-2*ta+2*1i*tab);
    ab=[tab/2 (tab-2)/(2*z0);(tab+2)*z0/2 tab/2];
    b=[(tb-2*1i)/2 tb/2;tb/2 (tb+2*1i)/2];
    a=ab*b^-1;
else
    tC=ta^2+tb^2+tab^2-ta*tb*tab-2; %Grandma's three parameter double alarm
    Q=sqrt(2-tC);
    if abs(tC+1i*Q*sqrt(tC+2))>=2
        R=sqrt(tC+2);
    else
        R=-sqrt(tC+2);
    end
    zo=(tab-2)*(tb-R)/(tb*tab-2*ta+1i*Q*tab);
    a=[ta/2 (ta*tab-2*tb+2i*Q)/((2*tab+4)*zo);(ta*tab-2*tb-2i*Q)*zo/(2*tab-4) ta/2];
    b=[(tb-1i*Q)/2 (tb*tab-2*ta-1i*Q*tab)/((2*tab+4)*zo);(tb*tab-2*ta+1i*Q*tab)*zo/(2*tab-4) (tb+1i*Q)/2];
end
if opt==3
    c=-1i/(2^(1/2));
    p=(1-c^2)/(1i*c);
    q=-c;
    r=c;
    s=1i*c;
    C=[p q;r s];
    a=C*a*C^-1;
    b=C*b*C^-1;
end
if opt==1 %Jorgensen's recipe
    a=[ta-tb/tab ta/tab/tab;ta tb/tab];
    b=[tb-ta/tab -tb/tab/tab;-tb ta/tab];
end

% function [a,b]=grandma(ta,tb,posroot,opt,tab)
% if nargin<4
%     opt=0;
% end
% if nargin<5
%     opt=mod(opt,2);
% end
% if nargin<3
%     posroot=false;
% end
% if opt<2 %Calculate the trace Tab from the grandfather identity
%     p=-ta*tb;
%     q=ta^2+tb^2;
%     if posroot
%         tab=(-p+(p^2-4*q)^0.5)/2;
%     else
%         tab=(-p-(p^2-4*q)^0.5)/2;
%     end
%     z0=((tab-2)*tb)/(tb*tab-2*ta+2*1i*tab);
%     if opt==0 %Grandma's original recipe
%     ab=[tab/2 (tab-2)/(2*z0);(tab+2)*z0/2 tab/2];
%     b=[(tb-2*1i)/2 tb/2;tb/2 (tb+2*1i)/2];
%     a=ab*b^-1;
%     end
%     if opt==1 %Jorgensen's recipe
%     a=[ta-tb/tab ta/tab/tab;ta tb/tab];
%     b=[tb-ta/tab -tb/tab/tab;-tb ta/tab];
%     end
%  else
%     tC=ta^2+tb^2+tab^2-ta*tb*tab-2; %Grandma's three parameter double alarm
%     Q=sqrt(2-tC);
%     if abs(tC+1i*Q*sqrt(tC+2))>=2
%         R=sqrt(tC+2);
%     else
%         R=-sqrt(tC+2);
%     end
%     zo=(tab-2)*(tb-R)/(tb*tab-2*ta+1i*Q*tab);
%     a=[ta/2 (ta*tab-2*tb+2i*Q)/((2*tab+4)*zo);(ta*tab-2*tb-2i*Q)*zo/(2*tab-4) ta/2];
%     b=[(tb-1i*Q)/2 (tb*tab-2*ta-1i*Q*tab)/((2*tab+4)*zo);(tb*tab-2*ta+1i*Q*tab)*zo/(2*tab-4) (tb+1i*Q)/2];
% end