function pltmus(p,q,col,siz)
%plots mu roots for p/q
% e.g. pltmus(); plots all available roots
% e.g. pltmus(7,25); 
%e.g. pltmus(7,25,[1 0 0]);
%e.g. pltmus(7,25,[1 0 0],20);
if nargin<4
    siz=5;
end
if nargin<3
    col=[0 0 0];
end
if nargin<2
    p=1;
end
if nargin<1
    q=0;
end
load mus
clf
hold on
if q==0
    for i=1:length(u)
        pltmu(u{i},col,siz);
    end
else
    pos=1;
    for i=1:q-1
        pos=pos+floor(i/2);
    end
    pos=pos+p;
    fprintf('%d\n',pos);
    m=u{pos};
    for i=1:length(m)
        fprintf('%d %4.4f+i%4.4f\n',i,real(m(i)),imag(m(i)));
    end
    pltmu(u{pos},col,siz);
end

function pltmu(ss,b,s)
tt=-real(ss)+1i*imag(ss);
plot(1i*ss,'.','Color',b,'Markersize',s);
plot(1i*tt,'.','Color',b,'Markersize',s);
plot(1i*(-2i-ss),'.','Color',b,'Markersize',s);
plot(1i*(-2i-tt),'.','Color',b,'Markersize',s);
plot(1i*conj(tt),'.','Color',b,'Markersize',s);
plot(1i*(2i-conj(tt)),'.','Color',b,'Markersize',s);
plot(1i*conj(ss),'.','Color',b,'Markersize',s);
plot(1i*(2i-conj(ss)),'.','Color',b,'Markersize',s);
axis([-2.1 2.1 -2.1 2.1]);
axis([-2.1 2.1 -2.1 2.1]);