function pltmuscol51(opt)
%plots roots forming the Maskit slice 
%opt=0 usual free version 2 non-free
%requires mus.mat and mus0.mat for trace values
clf
hold on
for i=51:-1:1
    col=[1-(i-1)/50,0,(i-1)/50];
    for j=1:floor(i/2);
        pltmus(j,i,col,5,opt);
        fprintf('%d %d\n',j,i);
    end
end

function pltmus(p,q,col,siz,opt)
%plots mu roots for p/q
% e.g. pltmus(); plots all available roots
% e.g. pltmus(7,25); 
%e.g. pltmus(7,25,[1 0 0]);
%e.g. pltmus(7,25,[1 0 0],20);
if nargin<5
    opt=0;
end
if nargin<4
    siz=5;
end
if nargin<3
    col=[0 0 0];
end
if nargin<2 
    p=1;
end
if nargin<1
    q=0;
end
if opt==2
    load mus0
else
    load mus
end
%clf
%hold on
if q==0
    for i=1:length(u)
        pltmu(u{i},col,siz,opt);
    end
else
    pos=1;
    for i=1:q-1
        pos=pos+floor(i/2);
    end
    pos=pos+p;
   % fprintf('%d\n',pos);
    m=u{pos};
    for i=1:length(m)
       % fprintf('%d %4.4f+i%4.4f\n',i,real(m(i)),imag(m(i)));
    end
    pltmu(u{pos},col,siz,opt);
end

function pltmu(ss,b,s,opt)
tt=-real(ss)+1i*imag(ss);
if opt==0
    h=2i;
else
    h=sqrt(2)*1i;
end
plot(1i*ss,'.','Color',b,'Markersize',s);
plot(1i*tt,'.','Color',b,'Markersize',s);
plot(1i*(-h-ss),'.','Color',b,'Markersize',s);
plot(1i*(-h-tt),'.','Color',b,'Markersize',s);
plot(1i*conj(tt),'.','Color',b,'Markersize',s);
plot(1i*(h-conj(tt)),'.','Color',b,'Markersize',s);
plot(1i*conj(ss),'.','Color',b,'Markersize',s);
plot(1i*(h-conj(ss)),'.','Color',b,'Markersize',s);
axis([-2.1 2.1 -2.1 2.1]);