function [M,comm,tab,a,b]=qFstochasticom(A,B,scope,rpts,siz,scal,opt,sav,tcomm,typ,offs,M)

%qFstochasticom(2,2,10,10,1100,1,0,2); %Apollonian gasket
%qFstochasticom(2,2,10,10,1100,2,1,2); %As above using the Jorgensen parametrization
%M=qFstochasticom(1.991+0.05i,1.93-0.05i,120,1,1100,1,2,1,2.2-1.8i,M);
%Non-parabolic commutators using 3 params
%qFstochasticom(2,2,10,10,1100,1,8,2,-1.99-0.4i);
%Recalculating using an existing matrix 
%M=qFstochasticom(1.91+0.05i,1.91+0.05i,10,1,1100,1/28,0,2,0,0,0,M);

%qFstochasticom(2,2,10,10,1100,0.3,0,2,0,0);
%qFstochasticom(2,2,10,10,1100,1.6,0,2,-1,0);
%qFstochasticom(2,2,10,10,1100,3,0,2,1,0);
%qFstochasticom(2,2,10,10,1100,0.6,0,2,-2*cos(2*pi/7),0);
%qFstochasticom(2,2,10,10,1100,0.16,3,2,-2*cos(2*pi/7),0);

%qFstochasticom(2,2,10,10,1100,0.1,2,2,-1,8);

% qFstochasticom(2,1.95+0.05i,10,10,1100,0.2,1,2,-1,4);
% qFstochasticom(1.98+0.05i,2,10,10,1100,0.2,2,2,-1,6);

% qFstochasticom(1.98+0.05i,1,10,10,1100,0.2,2,2,-1,6);
% qFstochasticom(1.95+0.05i,1,10,10,1100,0.3,2,2,-1,8,-i);
% qFstochasticom(1.95+0.05i,1,10,10,1100,1,2,2,-2*cos(2*pi/7),6,1.1);
% qFstochasticom(1.95+0.05i,1,10,10,1100,3,8,2,-2*cos(2*pi/7),0,0);
% qFstochasticom(1.91+0.0325i,0.9280+1.7434i,160,10,1100,0.1,8,2,-2*cos(2*pi/7),6,1+2i); 
% tab=gettraces(1.91+0.0325i,1,-2*cos(2*pi/7),1)
% qFstochasticom(1.95+0.05i,1.2509-1.6656i,10,10,1100,0.18,0,2,-1,6,1-2i); 
% tab=gettraces(1.95+0.05i,2*cos(2*pi/7),-1,1)
% qFstochasticom(1.95+0.05i,1.2495-1.7368i,10,10,1100,0.18,0,2,-2*cos(2*pi/7),6,1-2i);
%gettraces(1.95+0.05i,2*cos(2*pi/7),-2*cos(2*pi/7),1)
% qFstochasticom(1+i,1-i,10,10,1100,0.09,0,2,1,6,0);
% qFstochasticom(i,sqrt(2),60,10,1100,0.5,0,2,((1+sqrt(5))/2)^2+2,0,0);
%[M,comm,tab,a,b]=qFstochasticom(i,sqrt(2),10,10,1100,0.5,0,2,(2*cos(pi/5))^2+2,0,0);
% qFstochasticom(1.6088+0.6664i,-1.6088+0.6664i,10,10,1100,0.28,0,2,0,6,-1+i/2);%
% qFstochasticom(1.6088+0.6664i,-1.6088+0.6664i,10,10,1100,0.1,2,2,0,6,-1+i/2);


%The program generate a limit set from random iterations of the generators 
%using commutators and related starting points
%Its value lies in its ability to form a very approximate representation of 
%just about any limit set at all, including non-discrete and non-free examples.
%It initially starts from 4 fixed points of the limit set
%plus 30 points selected from the period 4 orbit a*b*a^-1*b^-1 repeating,
%which helps to picture the Jordan curve features of quasi-Fuchsian sets

%A,B are two traces used to generate a conjugacy class of matrices a,b
%scope runs 10*scope^2 pseudorandom sequences scope times
%rpts adds multiple repeats of the random process
%siz (default=1100) is the image size 
%scal (default=1) scales the image
%opt=0 gives standard view grandma short form tcomm=-2, 1 Jorgensen view 
% 3 Maskit parametrization. Usually requires trace(b) to be 2.
% 2 gives the grandma double alarm 3 parameters for arbitrary tab
%add 8 to select the opposite tab root for typ 0,1,3-4 otherwise 0->2 for typ 2,4-9.
%add 4 for the positive root of the short form of grandma assuming tcomm=-2
%and for original vs grandma-based symmetric
%sav=1,3 saves the matrix, and a png file sav>=2 does clf first
%tcomm is an entry for the trace(abAB) (default -2)
%typ allows for several normalizations (see line 100 default=0 grandma)
%offs moves the image centre (default=0)
%M is a re-input of the output matrix to add further points (default null matrix of white ones)

if nargin<9
    tcomm=-2;
end

ta=A;
tb=B;
p=-ta*tb;
q=ta^2+tb^2-tcomm-2;
if opt>=8
    tab=(-p+sqrt(p^2-4*q))/2;
else
    tab=(-p-sqrt(p^2-4*q))/2;
end
if mod(opt,8)>=4
    opt2=1;
else
    opt2=0;
end
opt=mod(opt,4);

if nargin<5
    siz=600;
end
if nargin<6
    scal=1;
end;
if nargin<7
    opt=0;
end
if nargin<8
    sav=0;
end
if nargin<9
    tab=2-2i;
end
if nargin<10
    typ=0;
end
if nargin<12
    M=ones(siz,siz);
end
if nargin<11
    offs=0;
end
if sav>=2
    clf;
end
tic; 
hold on
switch typ
    case 1
        [a,b]=polar(A,B,opt2,opt,tab);
    case 2
        [a,b]=symmetric(A,B,opt2,opt,tab,tcomm);
    case 3
        [a,b]=canonical(A,B,1,opt,tab,tcomm);
    case 4
        [a,b]=canoncomm(A,B,opt2,opt,tab,tcomm);
    case 5 %recreate grandma
        [a,b,c]=symmetric(A,B,opt2,opt,tab,tcomm);
        a=b;
        b=c*b^2;
        a=a^-1; 
    case {6,7,8,9} 
        [a,b,c]=symmetric(A,B,opt2,opt,tab,tcomm);
        switch typ 
            case 6 %self-inverse 1
                c=[1 1;-1 1];
            case 7 %si 2
                c=0.5*[1+1i -1+1i;1+1i 1-1i];
            case 8 %asi 1
                c=0.5*[1+1i -1-1i;-1+1i -1+1i];
            case 9 %asi 2
                c=[1+1i 1-1i;1-1i 1+1i];        
        end
        d=c^-1;
        a=c*a*d;
        b=c*b*d;
    case 10 %Jorgensen    
        [a,b]=grandma(A,B,opt2,1,tab);
    case 11 %Maskit
        [a,b]=grandma(A,B,opt2,3,tab); 
    otherwise
        [a,b]=grandma(A,B,opt2,opt,tab);
end
comm=a*b*a^-1*b^-1;
z=zeros(1,4);
j=1;
for i=1:4
    zh=fixp(a,b,i);
    if ~isnan(zh)
        z(j)=zh;
        j=j+1;
    end
end
z2=testq6(a,b);
z=[z(1:j-1) z2];
M=testq2b2(a,b,opt,10*scope,rpts,z,[-1.1 1.1 -1.1 1.1],M,siz,scal,offs);
toc;
s=size(M);
tit=[num2str(A),', ',num2str(B),', ',num2str(scope),', ',num2str(rpts)];
tit2=[num2str(A),'-',num2str(B),'-',num2str(scope),'-',num2str(rpts)];
z=zeros(1,s(1)*s(2));
k=1;
sc11=1;
for i=1:s(1)
    for j=1:s(2)
        if M(i,j)==0
            z(k)=((i-s(1)/2)*2/s(1)+1i*(j-s(2)/2)*2/s(2))*sc11;
            k=k+1;
        end
    end
end
plot(z(1:k-1),'.','MarkerSize',1,'Color','k');
axis([-sc11 sc11 -sc11 sc11]);
text(-1,1.05,tit);
if mod(sav,2)==1
%imwrite(255*M',[tit,'.tiff']);
imwrite(255*M',[tit,'.png']);
save([tit2,'.mat'],'M');
%saveas(gcf,[tit,'.eps'],'eps');
end
        
function M=testq2b2(a,b,opt,its,repts,z,D,M,siz,scal,offs)
if nargin<7
    D=[-2 2 0 2];
end
if nargin<4
    repts=1000;
end
if nargin<3
    opt=0;
end
for i=1:repts
    %tic;
    rng('shuffle') 
    M=quasi2f(a,b,its^2,its,z,D,opt,M,siz,scal,offs);
    %toc;
    %fprintf('%d\n',i);
end

function M=quasi2f(a,b,its,repts,z,A,opt,M,siz,scal,offs)
siz=siz/2;
sizs=10/11*siz;
if nargin<3
its=1000000;
end
if nargin<4
repts=10;
end
if nargin<7
    opt=0;
end
rh=zeros(1,4);
L=length(z);
Z=z;
for i=1:L
    zs=scal*(z+offs);
    if ~isnan(zs(i))
        if max(abs(real(zs(i))),abs(imag(zs(i))))<1
           M(siz+floor(sizs*real(zs(i))),siz+floor(sizs*imag(zs(i))))=0;
%            if ~opt
%               M(siz+floor(sizs*real(-zs(i))),siz+floor(sizs*imag(-zs(i))))=0;
%            end
        end
    end
end
stps=its/repts;
for k=0:repts-1
    for j=1+k*stps:stps+k*stps
        if j==1
            z=Z;
        else
            z=zh;
        end
        rr=floor(4*rand());
        kh=4;
        if j>1
            while rr==mod(rh(4)+2,4)
                rr=floor((4+kh)*rand());
            end
            if rr>3
                rr=rh(4);
            end
        end
        switch rr      
             case 0
                z=(a(1,1).*z+a(1,2))./(a(2,1).*z+a(2,2));
             case 2
                z=(-a(2,2).*z+a(1,2))./(a(2,1).*z-a(1,1));
             case 1
                z=(b(1,1).*z+b(1,2))./(b(2,1).*z+b(2,2));
             case 3
                z=(-b(2,2).*z+b(1,2))./(b(2,1).*z-b(1,1));
        end
        zh=z;
        rh(1:3)=rh(2:4);
        rh(4)=rr;
        for i=1:L
            zs=scal*(z+offs);
            if ~isnan(zs(i))
                if max(abs(real(zs(i))),abs(imag(zs(i))))<1
                   M(siz+floor(sizs*real(zs(i))),siz+floor(sizs*imag(zs(i))))=0;
%                    if ~opt
%                       M(siz+floor(sizs*real(-zs(i))),siz+floor(sizs*imag(-zs(i))))=0;
%                    end
                end
            end
        end
    end
end

function z=testq6(a,b)
[x,y]=testq4(a,b,'0123','w',1000,20,0);
z=nexus(x,y,2);
[x,y]=testq4(a,b,'3210','w',1000,20,0);
z2=nexus(x,y,0);
z=[z z2];

function zzzz=nexus(x,y,m)
z=x+1i*y;
j=1;
for i=1:length(z)
    if mod(i,4)==m
        zz(j)=z(i);
        j=j+1;
    end
end
zzz=logspace(0,log(length(zz))/log(10),15);
for i=1:length(zzz)
    zzzz=zz(floor(zzz));
end

function [x,y]=testq4(a,b,s,c,its,siz,pl)
if nargin<7
    pl=0;
end
x=zeros(1,its);
y=x;
z=fixp(a,b,0);
x(1)=real(z);
y(1)=imag(z);
for j=1:its
    z=x(j)+1i*y(j);
    rp=s(mod(j,length(s))+1);
    if strcmp(rp,'0')
        rr=0;
    end
    if strcmp(rp,'1')
        rr=1;
    end
    if strcmp(rp,'2')
        rr=2;
    end
    if strcmp(rp,'3')
        rr=3;
    end
    switch rr      
         case 0
            z=(a(1,1)*z+a(1,2))/(a(2,1)*z+a(2,2));
         case 2
            z=(-a(2,2)*z+a(1,2))/(a(2,1)*z-a(1,1));
         case 1
            z=(b(1,1)*z+b(1,2))/(b(2,1)*z+b(2,2));
         case 3
            z=(-b(2,2)*z+b(1,2))/(b(2,1)*z-b(1,1));
    end
    x(j+1)=real(z);
    y(j+1)=imag(z);

end
if pl
plot(z,'.','MarkerSize',siz,'Color',c);
plot(z(1),'.','MarkerSize',siz,'Color','g');
plot(z(end),'.','MarkerSize',siz,'Color','r');

end

function z=fixp(a,b,ri)
        if ri==0
            ri=floor(4*rand()); %find a fixed point from one of the transforms
        end
        %ri=5;
        switch ri
            case {0,4}
                z=(-(a(2,2)-a(1,1))+sqrt((a(2,2)-a(1,1))^2+4*a(1,2)*a(2,1)))/(2*a(2,1));
            case 1
                z=(-(a(2,2)-a(1,1))-sqrt((a(2,2)-a(1,1))^2+4*a(1,2)*a(2,1)))/(2*a(2,1));
            case 2
                z=(-(b(2,2)-b(1,1))+sqrt((b(2,2)-b(1,1))^2+4*b(1,2)*b(2,1)))/(2*b(2,1));
            case 3
                z=(-(b(2,2)-b(1,1))-sqrt((b(2,2)-b(1,1))^2+4*b(1,2)*b(2,1)))/(2*b(2,1));
            case 5
                c=a*b*a^-1*b^-1;
                z=(-(c(2,2)-c(1,1))-sqrt((c(2,2)-c(1,1))^2+4*c(1,2)*c(2,1)))/(2*c(2,1));
        end
% function [a,b]=grandma(ta,tb,posroot,opt,tab)
% if nargin<5
%     tab=2-2i;
% end
% if nargin<4
%     opt=0;
% end
% if nargin<3
%     posroot=false;
% end
% if opt~=2
%     p=-ta*tb;
%     q=ta^2+tb^2;
%     if posroot
%         tab=(-p+(p^2-4*q)^0.5)/2;
%     else
%         tab=(-p-(p^2-4*q)^0.5)/2;
%     end
%     z0=((tab-2)*tb)/(tb*tab-2*ta+2*1i*tab);
%     if opt==0 || opt==3
%     ab=[tab/2 (tab-2)/(2*z0);(tab+2)*z0/2 tab/2];
%     b=[(tb-2*1i)/2 tb/2;tb/2 (tb+2*1i)/2];
%     a=ab*b^-1;
%     end
%     if opt==1
%     a=[ta-tb/tab ta/tab/tab;ta tb/tab];
%     b=[tb-ta/tab -tb/tab/tab;-tb ta/tab];
%     end
%     if opt==3
%         c=-1i/(2^(1/2));
%         p=(1-c^2)/(1i*c);
%         q=-c;
%         r=c;
%         s=1i*c;
%         C=[p q;r s];
%         a=C*a*C^-1;
%         b=C*b*C^-1;
%     end
%  else
%     tC=ta^2+tb^2+tab^2-ta*tb*tab-2;
%     Q=sqrt(2-tC);
%     if abs(tC+1i*Q*sqrt(tC+2))>=2
%         R=sqrt(tC+2);
%     else
%         R=-sqrt(tC+2);
%     end
%     zo=(tab-2)*(tb-R)/(tb*tab-2*ta+1i*Q*tab);
%     a=[ta/2 (ta*tab-2*tb+2i*Q)/((2*tab+4)*zo);(ta*tab-2*tb-2i*Q)*zo/(2*tab-4) ta/2];
%     b=[(tb-1i*Q)/2 (tb*tab-2*ta-1i*Q*tab)/((2*tab+4)*zo);(tb*tab-2*ta+1i*Q*tab)*zo/(2*tab-4) (tb+1i*Q)/2];
% end
% function [a,b]=grandma(ta,tb,posroot,opt,tab)
% if nargin<3
%     posroot=false;
% end
% if nargin<4
%     opt=0;
% end
% if nargin<5 %Calculate the trace Tab from the grandfather identity
%     p=-ta*tb;
%     q=ta^2+tb^2;
%     if posroot
%         tab=(-p+(p^2-4*q)^0.5)/2;
%     else
%         tab=(-p-(p^2-4*q)^0.5)/2;
%     end
%     z0=((tab-2)*tb)/(tb*tab-2*ta+2*1i*tab);
%     ab=[tab/2 (tab-2)/(2*z0);(tab+2)*z0/2 tab/2];
%     b=[(tb-2*1i)/2 tb/2;tb/2 (tb+2*1i)/2];
%     a=ab*b^-1;
% else
%     tC=ta^2+tb^2+tab^2-ta*tb*tab-2; %Grandma's three parameter double alarm
%     Q=sqrt(2-tC);
%     if abs(tC+1i*Q*sqrt(tC+2))>=2
%         R=sqrt(tC+2);
%     else
%         R=-sqrt(tC+2);
%     end
%     zo=(tab-2)*(tb-R)/(tb*tab-2*ta+1i*Q*tab);
%     a=[ta/2 (ta*tab-2*tb+2i*Q)/((2*tab+4)*zo);(ta*tab-2*tb-2i*Q)*zo/(2*tab-4) ta/2];
%     b=[(tb-1i*Q)/2 (tb*tab-2*ta-1i*Q*tab)/((2*tab+4)*zo);(tb*tab-2*ta+1i*Q*tab)*zo/(2*tab-4) (tb+1i*Q)/2];
% end
% if opt==3
%     c=-1i/(2^(1/2));
%     p=(1-c^2)/(1i*c);
%     q=-c;
%     r=c;
%     s=1i*c;
%     C=[p q;r s];
%     a=C*a*C^-1;
%     b=C*b*C^-1;
% end
% if opt==1 %Jorgensen's recipe
%     a=[ta-tb/tab ta/tab/tab;ta tb/tab];
%     b=[tb-ta/tab -tb/tab/tab;-tb ta/tab];
% end
