function [e,tt]=tracepq(p,q,opt,prt)
%opt=0 f=2 root, 1 f=-2 root; 2,3 non free Tcom=0 ; 4,5 Tcom=1  6,7 Tcom=-1 %8,9 Tcom=-1.8 1|7
% e.g. [e,tt]=tracepq(5,7,0,1); will list the roots in e and sorted in tt
% In this case the keey solution is e(1) which we can confirm by calling
% depthfirst(e(1),2,0.001,1000,1,0);
tic;
syms t
g=gcd(p,q);
p=p/g;
q=q/g;
s=fareyseq(p,q);
t0=t;
switch floor(opt/2)
    case 0
        t1=t+2i;
    case 1
        t1=t+sqrt(2)*1i;
    case 2
        t1=t+1i;
    case 3
        t1=t+sqrt(3)*1i;
    case 4
        t1=t+sqrt(1.80193774+2)*1i;
end
t2=2;
for i=1:length(s)
    if s(i)==0
       h=expand(t1*t0-t2);
       t2=t1;
       t1=h;       
    else
       h=expand(t1*t2-t0);
       t0=t1;
       t1=h;       
    end
    %fprintf('.');
end
%fprintf('\n');
c=expand(t1); %Expand it into polynomial form
f=symfun(c,t); %Make it into a function we can solve
%f=vpa(f,20);
toc;
if mod(opt,2)==0
   e=eval(vpasolve(f==2,t)); %Solve it for f=2
else
   e=eval(vpasolve(f==-2,t));  
end
q=q/gcd(p,q);
    tt=zeros(length(e),3);
    for i=1:q
        tt(i,1)=i;
        tt(i,2)=real(e(i));
        tt(i,3)=imag(e(i));
    end
    tt=sortrows(tt,2);
if prt
    for i=1:q
        if tt(i,3)>=0
            fprintf('%d\t%4.8f+%4.8fi\n',tt(i,1),tt(i,2),tt(i,3));
        else
            fprintf('%d\t%4.8f%4.8fi\n',tt(i,1),tt(i,2),tt(i,3));
        end
    end
    
end
toc;

function s=fareyseq(p,q)
p=p/gcd(p,q);
q=q/gcd(p,q);
s=[];
p0=0;
q0=1;
p1=1;
q1=0;
ph=p0+p1;
qh=q0+q1;
while p~=ph || q~=qh
    if ph/qh>p/q
        p1=ph;
        q1=qh;
        ph=ph+p0;
        qh=qh+q0;
        s=[s 0];
    else
        p0=ph;
        q0=qh;
        ph=ph+p1;
        qh=qh+q1;
        s=[s 1];
    end
end