function [v,i]=tracepqr(p,q,opt,val,ep)
%opt=0 f==2 root 1 f==-2 2 non free f==2 3 non free f==-2
%e.g.v=tracepqr(1597,2584,0,1.61691788-1.29437374i,1e-8)  %233/377
tic;
g=gcd(p,q);
p=p/g;
q=q/g;
s=[]; % Generate Farey sequence for p/q
p0=0;
q0=1;
p1=1;
q1=0;
ph=p0+p1;
qh=q0+q1;
while p~=ph || q~=qh
    if ph/qh>p/q
        p1=ph;
        q1=qh;
        ph=ph+p0;
        qh=qh+q0;
        s=[s 0];
    else
        p0=ph;
        q0=qh;
        ph=ph+p1;
        qh=qh+q1;
        s=[s 1];
    end
end
h=(1+1i)*1e-7;
its=500;
v=zeros(1,its+1);
v(1)=val;
for i=1:its %Newton's iteration loop
    f=fracfunct(s,opt,val)-2;
    df=(fracfunct(s,opt,val+h)-fracfunct(s,opt,val-h))/2/h;
    val=val-f/df;
    v(i+1)=val;
    if abs(v(i+1)-v(i))<ep
        fprintf('OK %d %4.12f %4.12f %4.12fi\n',i, abs(v(i+1)-v(i)),real(v(i)),imag(v(i)));
        break;
    end
end
if i==its
    fprintf('Bad:%d %4.12f %4.12f\n',i,real(v(i)),imag(v(i)));
end
clf;
hold on
plot(v(1:i+1),'b');
plot(v(1:ceil(1/10*i)),'g');
plot(v(ceil(i*9/10:i)),'r');
v=v(1:i+1);
toc

function t1=fracfunct(s,opt,val)
t0=val;
if opt<2
    t1=val+2i;
else
    t1=val+sqrt(2)*1i;
end
t2=2;
for i=1:length(s)
    if s(i)==0
       h=t1*t0-t2;
       t2=t1;
       t1=h;       
    else
       h=t1*t2-t0;
       t0=t1;
       t1=h;       
    end
end